abclinuxu.cz AbcLinuxu.cz itbiz.cz ITBiz.cz HDmag.cz HDmag.cz abcprace.cz AbcPráce.cz
AbcLinuxu hledá autory!
Inzerujte na AbcPráce.cz od 950 Kč
Rozšířené hledání
×
včera 01:00 | Nová verze

Po více než pěti měsících od vydání verze 3.11.0 byla vydána nová stabilní verze 3.12.0, tj. první z nové řady 3.12, minimalistické linuxové distribuce zaměřené na bezpečnost Alpine Linux (Wikipedie) postavené na standardní knihovně jazyka C musl libc a BusyBoxu. Z novinek lze zmínit počáteční podporu architektury mips64 (big endian) a programovacího jazyka D.

Ladislav Hagara | Komentářů: 1
29.5. 23:00 | Komunita

Coffee Run je další krátký open source film od Blender Animation Studia. Vše o filmu na Blender Cloudu.

Ladislav Hagara | Komentářů: 5
29.5. 16:33 | Nová verze

Byla vydána nová verze 2020.06.01 distribuce BlackArch Linux (Wikipedie). Jedná se o distribuci založenou na Arch Linuxu zaměřenou na penetrační testování a výzkum počítačové bezpečnosti. Z novinek lze zmínit přes 150 nových nástrojů. Aktuálně jich je 2553.

Ladislav Hagara | Komentářů: 0
29.5. 14:11 | Komunita

V dubnu loňského roku získal multiplatformní open source herní engine Godot (Wikipedie) 50 tisíc dolarů z programu Mozilla Open Source Support (MOSS) Mission Partners na portaci Godot Editoru na webové technologie (HTML5 a WebAssembly), vylepšení podpory WebRTC, přidání podpory WebSocket a vytvoření 3D modelů pro nová dema. Fabio Alessandrelli dnes přestavil jeden z výsledků: Godot Editor běžící ve webovém prohlížeči.

Ladislav Hagara | Komentářů: 0
29.5. 13:44 | Nová verze

Včera bylo oznámeno přejmenování Raspbianu, tj. linuxové distribuce určené především pro jednodeskové miniaturní počítače Raspberry Pi, na Raspberry Pi OS. Dnešní příspěvek na blogu Raspberry Pi a také video na YouTube představuje květnové novinky již v Raspberry Pi OS, konkrétně ve verzi 2020-05-27. Zdůrazněny jsou například nové aplikace Bookshelf a Magnifier. Detaily v poznámkách k vydání.

Ladislav Hagara | Komentářů: 0
29.5. 11:11 | Pozvánky

Dnes od 16:00 do 19:15 a zítra od 9:00 do 15:00 lze virtuálně navštívit festival novodobých kutilů Maker Faire Prague Online 2020.

Ladislav Hagara | Komentářů: 0
28.5. 22:22 | Zajímavý projekt

S pomocí 3D tiskárny vyrobitelná klávesnice Katy K80CS (Deskthority, Geekhack) inspirovaná Kinesis Advantage je nyní open hardware – včetně souborů STL nově pod licencí Creative Commons BY-SA. Firmware byl dostupný již dříve. Jedná se o alternativu k populárnímu projektu Dactyl s řadou forků včetně varianty Dactyl-Manuform (viz též galerii, kterou spravuje Xah Lee).

Fluttershy, yay! | Komentářů: 73
28.5. 22:11 | Nová verze

Android Studio (Wikipedie), tj. oficiální integrované vývojové prostředí pro vývoj aplikací pro mobilní operační systém Android, bylo vydáno v nové stabilní verzi 4.0. Přehled novinek i s náhledy v oficiálním oznámení a také na YouTube.

Ladislav Hagara | Komentářů: 0
28.5. 15:33 | Nová verze

Byla vydána verze 1.14 systému pro správu a verzování zdrojových kódů Apache Subversion (Wikipedie). Jedná se o LTS verzi. Přehled novinek v poznámkách k vydání.

Ladislav Hagara | Komentářů: 7
28.5. 14:22 | IT novinky

V červnu loňského roku bylo představeno Raspberry Pi 4 s 1 GB, 2 GB a 4 GB RAM. Dnes přibyla varianta s 8 GB RAM za 75 dolarů. Současně bylo oznámeno přejmenování Raspbianu na Raspberry Pi OS. K dispozici je beta verze 64bitové varianty. Minulý týden byla oznámena beta verze firmwaru umožňujícího bootování Raspberry Pi 4 z USB místo z SD karty.

Ladislav Hagara | Komentářů: 9
Kdy přecházíte na nové vydání distribuce/OS?
 (14%)
 (13%)
 (21%)
 (7%)
 (3%)
 (41%)
Celkem 357 hlasů
 Komentářů: 0
Rozcestník

Dotaz: prechadzanie logov

19.4. 20:02 tom
prechadzanie logov
Přečteno: 448×
Ahojte, Zacal som sa ucit bash a narazil na problem.V ucebnici je uvedeny tento priklad>
find . -exec sh -c 'echo -n {} | tr -d "[:alphanum:]_.\-" | tr "/" " "; basename {}'\;

Ale ja dostanem len toto>
$ find . -exec sh -c 'echo -n {} | tr -d "[:alphanum:]_.\-" | tr "/" " "; basename {}'\;
find: missing argument to `-exec'
Try 'find --help' for more information.
Prosim kde je chyba?

Dakujem

Řešení dotazu:


Odpovědi

19.4. 20:05 Aleš Kapica | skóre: 50 | blog: kenyho_stesky | Ostrava
Rozbalit Rozbalit vše Re: prechadzanie logov
Neukončená jednoduchá uvozovka. Trochu víc pozornosti by to chtělo.
19.4. 20:10 Peter Golis | skóre: 60 | blog: Bežné záležitosti | Bratislava
Rozbalit Rozbalit vše Re: prechadzanie logov
Úvodzovky má v poriadku.
19.4. 20:29 Aleš Kapica | skóre: 50 | blog: kenyho_stesky | Ostrava
Rozbalit Rozbalit vše Re: prechadzanie logov
Odpřísáhnul bych, že když jsem na to koukal na mobilu, tak se ty řádky lišily tím, že chyběla ta jednoduchá uvozovka před tím zpětným lomítkem na konci. Jinak ta chybějící mezera samozřejmě, ano.
19.4. 21:10 Dejv | skóre: 37 | blog: Jak ten blog nazvat ... ? | Ostrava
Rozbalit Rozbalit vše Re: prechadzanie logov
Dopr... prestante (a nemam na mysli jenom Alese Kapicu, ale obecne kohokoliv) uz konecne s tema "jendoduchyma uvozovkama"!!! Cestina nic takoveho nema!!!

To ze anglictina ma "single quotes" a "double qoutes' jeste neznamena, ze to tak ma i cestina!

Anglicke "double quotes" jsou uvozovky a "single qoutes" je apostrof!!! Nic jako "jednoduche" nebo "dvojite" uvozovky v cestine neexistuje!!!
Pevně věřím, že zkušenější uživatelé mě s mými nápady usměrní a pošlou tam, kam tyto nápady patří...
Gréta avatar 19.4. 21:34 Gréta | skóre: 23 | blog: Grétin blogísek | Stockholm
Rozbalit Rozbalit vše Re: prechadzanie logov

tttssssssssssss hedka řádeček 26 hele mi jako neřikej že češina nemá 'jednoduchý uvozovky' :O :D :D ;D

'apostrof' je jako uplně ten samej znak jako jednoduchá uvozovka hele a taky se dá ve skriptování/programování používat jako uvozovka a normálně voboje často jako funguje tak jako nevim co řešíš :O ;D

✊3 things to learn in skiing: •how to put on your skis •how to slide downhill •how to walk along the hospital corridor✊
19.4. 22:38 Dejv | skóre: 37 | blog: Jak ten blog nazvat ... ? | Ostrava
Rozbalit Rozbalit vše Re: prechadzanie logov
Nauc se
  1. Vkladatt tady odkazy
  2. cist a chapat vyznam psaneho textu
    Typografický apostrof (’) ... „americkou“ pravou jednoduchou uvozovkou (right single quotation mark)
    narozdil od
    Ve zdrojových kódech se používá ASCII apostrof ('),
    Jestli ti to nahodou nedoslo (a vzhledem ke tvemu zpusobu vyjadrovani bych se vubec nedivil), tak tady se jednalo o zdrojovy kod
Pevně věřím, že zkušenější uživatelé mě s mými nápady usměrní a pošlou tam, kam tyto nápady patří...
Gréta avatar 20.4. 13:01 Gréta | skóre: 23 | blog: Grétin blogísek | Stockholm
Rozbalit Rozbalit vše Re: prechadzanie logov

whatever jako :D

✊3 things to learn in skiing: •how to put on your skis •how to slide downhill •how to walk along the hospital corridor✊
20.4. 13:15 Aleš Kapica | skóre: 50 | blog: kenyho_stesky | Ostrava
Rozbalit Rozbalit vše Re: prechadzanie logov
Nauč se ty, balíku.
20.4. 13:29 Aleš Kapica | skóre: 50 | blog: kenyho_stesky | Ostrava
Rozbalit Rozbalit vše Re: prechadzanie logov
Omlouvám se za toho balíka. Podstatné je, že čeština pojem jednoduché uvozovky zná a běžně se používá. Přinejmenším proto aby se odlišil znak ' od .
20.4. 20:53 Dejv | skóre: 37 | blog: Jak ten blog nazvat ... ? | Ostrava
Rozbalit Rozbalit vše Re: prechadzanie logov
Omluva se prijima.

V typografii mozna jednoduche a dvojite uvozovky existuji. Nic to ale nemeni na tom, ze ve zdrojovych kodech (a o ten tady jde) zadne jednoduche nebo dvojite uvozovky v cestine neexistuji. Pouze uvozovky a apostrof.
Pevně věřím, že zkušenější uživatelé mě s mými nápady usměrní a pošlou tam, kam tyto nápady patří...
19.4. 20:09 Peter Golis | skóre: 60 | blog: Bežné záležitosti | Bratislava
Rozbalit Rozbalit vše Re: prechadzanie logov
Ako prvé tam chýba medzera pred koncom. Preklepov tam máš v tej domácej úlohe viacej.
Řešení 1× (Aleš Kapica)
19.4. 20:36 tom
Rozbalit Rozbalit vše Re: prechadzanie logov
Ano,

Dakujem, chybala tam medzera pred koncom a spravne ma byt [:alnum:].

Teraz ro uz ide :)
Řešení 1× (Gréta)
20.4. 00:05 Andrej | skóre: 47 | blog: Republic of Mordor | Zürich
Rozbalit Rozbalit vše Re: prechadzanie logov
V ucebnici je uvedeny tento priklad>

Zdráhám se uvěřit, že je tohle v nějaké učebnici. To není „příklad“, to je hnus:

  1. Nefunguje to (ani po výše zmíněných opravách). Co když bude v názvu souboru čárka nebo cokoliv dalšího (třeba z Unicode), co nepadne do [:alnum:] ani do těch několika málo dalších znaků?
  2. Katastrofa z hlediska efektivity. Kvůli každé nalezené položce spouštíš několik procesů. Obecně bych u find nedoporučoval používat -exec jinak než s + místo středníku. Když má člověk nutkání použít -exec se středníkem, je to obvykle špatný nápad a existuje efektivnější řešení:
find -printf '%d %f\n' | \
while read d f; do
  for ((i = 0; i < d; ++i)); do echo -n ' '; done
  echo "$f"
done
ǑǦŹǓǕǙǞǺǨȞȬḔḦḰḾṊṎṸẄẌỖ
20.4. 00:08 Aleš Kapica | skóre: 50 | blog: kenyho_stesky | Ostrava
Rozbalit Rozbalit vše Re: prechadzanie logov
Neřeš. Chtěl jenom vědět, proč mu to nefunguje.
20.4. 15:32 Andrej | skóre: 47 | blog: Republic of Mordor | Zürich
Rozbalit Rozbalit vše Re: prechadzanie logov

Neřeším. Jen se mi nelíbilo svádění děsivého příkazu na (nejmenovanou) učebnici. :-) Když něco napíšu jako prase, většinou se tím ještě chlubím. Že bych autorství tajil, to by mě nikdy ani nenapadlo.

ǑǦŹǓǕǙǞǺǨȞȬḔḦḰḾṊṎṸẄẌỖ
20.4. 15:46 Peter Golis | skóre: 60 | blog: Bežné záležitosti | Bratislava
Rozbalit Rozbalit vše Re: prechadzanie logov
A nebolo to z elektrickej učebnice kde bol text: "Upravte následovný príklad do funkčnej podoby"?

Za mňa to bol veľmi dobrý príklad, ale učiteľ si ten marker veľmi ľahko nájde.
20.4. 21:54 Andrej | skóre: 47 | blog: Republic of Mordor | Zürich
Rozbalit Rozbalit vše Re: prechadzanie logov

Uf. No to snad ne. Ono je to z Linux Shell Scripting Cookbook. Tak tomu bych nikdy nevěřil, kdybych to neviděl.

Dobře. Teď už aspoň vím, co nečíst.

ǑǦŹǓǕǙǞǺǨȞȬḔḦḰḾṊṎṸẄẌỖ
24.4. 14:26 tom
Rozbalit Rozbalit vše Re: prechadzanie logov
Mas pravdu je to z tej knihy. Je to uz 3. vydanie, tak som myslel,ze je to preverene.

Mozno sa neskor dopracujem a docitam k tvojej verzii skriptu. Vies mi poradit nejaky spolahlivy zdroj, knihu, ktoru povazujes za spolahlivu?

Dakujem
24.4. 17:22 Andrej | skóre: 47 | blog: Republic of Mordor | Zürich
Rozbalit Rozbalit vše Re: prechadzanie logov

Tady bohužel žádné doporučení nemám, protože sám jsem na toto téma žádnou knihu nečetl. Jediné, co jsem četl o Bashi, byla manuálová stránka.

ǑǦŹǓǕǙǞǺǨȞȬḔḦḰḾṊṎṸẄẌỖ
24.4. 18:26 Aleš Kapica | skóre: 50 | blog: kenyho_stesky | Ostrava
Rozbalit Rozbalit vše Re: prechadzanie logov
Ani já o programování v Bashi nic nečetl. Učil jsem se z jiných skriptů a z těch základních věcí jsem sesmolil takové stručné resumé v češtině na wikibooks.
25.4. 12:49 Andrej | skóre: 47 | blog: Republic of Mordor | Zürich
Rozbalit Rozbalit vše Re: prechadzanie logov

To je znamenité howto! Líbí se mi, jak je uspořádané podle „speciálních znaků“, ne podle abstraktních témat typu „substituce tohoto nebo tamtoho“. Proč mi tohle přijde pozitivní: Protože ten, kdo se snaží poprvé porozumět Bash skriptům, se s největší pravděpodobností v dané chvíli pokouší spíš pochopit nějaký existující skript než napsat nový od nuly. Pro někoho v takové situaci je mnohem přínosnější kapitola „Otazník“ než kapitola „O expanzích obecně“.

Jenom je tam pár věcí, které vypadají spíš jako z doby Bashe 3.x než z doby Bashe 5.x. Nechce se mi tam registrovat a stránka „Diskuse“ je tam beztak zatím prázdná, tak aspoň tady ve zkratce prodlužce:

  • Dvourozměrné pole:

    A=('abcd' 'dcba')
    Z=('zxyw' 'wxyu' 'tuxz')
    ARR=('A' 'Z')
    
    for row in "${ARR[@]}"; do
      echo "processing row: $row"
      declare -n arr="$row"  # <<< Tohle!
      for element in "${arr[@]}"; do
        echo "  processing element: $element"
      done
    done
    
  • Celkově tam chybí (podle mě hyper-užitečný) „operátor“ +=:

    somestring=blah
    somestring+=' blah'
    echo "$somestring"
    
    somearray=(blah)
    somearray+=(blah)
    echo "${somearray[@]}"
    
    declare -A anotherarray
    anotherarray=(['zee']=blah)
    anotherarray+=(['foo']=blahblah ['zee']=updated_blah)
    echo "${!anotherarray[@]}"
    echo "${anotherarray[@]}"
    for index in "${!anotherarray[@]}"; do
      echo "${index} -> ${anotherarray["${index}"]}";
    done
    
    declare -i someint
    someint=2
    someint+=3
    ((someint += 4))       # trochu "jiný" +=
    someint='someint + 5'  # aritmetika obecně
    echo "$someint"
    
  • V kapitole o „dvojitých kulatých závorkách“ by se hodilo uvést některé souvislosti (a co funguje s kterým „typem“ proměnné):

    declare -i a=0
    
    ((++a))
    ((a += 1))
    a=$((a + 1))
    echo "$a"
    
    a+=1
    a='a + 1'
    echo "$a"
    
  • U „příkladů substituce“ chybí zmínka o jednom snadno přehlédnutelném odstavci z manuálové stránky, který však leckdy znamená úsporu hodin úsilí a třískání hlavou do stolu:

    When not performing substring expansion, using the forms documented below (e.g., :-), bash tests for a parameter that is unset or null. Omitting the colon results in a test only for a parameter that is unset.

    Tohle^^^ v tom howto sice je popsané, ale až později a jenom v souvislosti s otazníkem. Plus a minus se s tím kamarádí taky:

    var_analysis() {
      local -n var="$1"
      echo "Variable '${1}'" \
           "${var+exists ("${1}='"}${var-does not exist}${var+"'")}" \
           "and is ${var:+set ("${1}='"}${var:-empty}${var:+"'")}."
    }
    
    unset a
    var_analysis a
    a=
    var_analysis a
    a=b
    var_analysis a
    a=
    var_analysis a
    unset a
    var_analysis a
    

    Leč na tohle pozor; to se mi nezdá, i když podle odpovědí to vypadá, že je (skoro) všechno v pořádku. (TL;DR: V kombinaci s poli všechno najednou přestává být zjevné a jednoduché.)

  • U veškeré té práce s poli a expanzemi chybí, jestli se dobře dívám, třešnička na dortu v podobě „vektorové“ aplikace substituce na celé pole:

    xml_files=({a..f}.xml)
    echo "${xml_files[@]}"
    text_files=("${xml_files[@]/%.xml/.txt}")
    echo "${text_files[@]}"
    
  • Jo a když už jsme u toho předchozího, tyhle tečkové expanze tam taky chybí:

    echo {a..z}{0..9}
    echo \({a..z}' 's' 'indexem' '{0..9}\)
    echo -ne \({a..z}' 's' 'indexem' '{0..9}')\n'
    
  • U těch „speciálních znaků masky“ velmi citelně chybí extglob, což bývá (podle mých zkušeností) ve většině dister zapnuté (jestli to už náhodou Bash nemá zapnuté implicitně pořád):

    echo /etc/@(passwd|group)
    

    Nejsou to sice úplně regexpy, ale v některých situacích to může výrazně pomoct. Ještě stojí za připomenutí, že u porovnání to funguje taky:

    [[ 'bac' = +(a|b|c) ]] && echo 'Jo!'
    
  • Ůůůfuf, tohle je sice pravda, ale je to mor, neštovice a rakovina v jednom:

    Jestliže rouře předchází rezervované slovo !, stav ukončení (exit status) této roury je "logické NOT stavu ukončení" (exit status) posledního příkazu. Jinak je exit status roury stav ukončení (exit status) posledního příkazu.

    Takže, jak se s tímhle vypořádat? Jak zajistit, abychom mohli správně detekovat selhání v kterékoliv sekci dýmky? Inu, jsou dvě možnosti. Buď set -o pipefail

    if (set -e; (exit 7;) | (exit 0;);); then
      echo 'Kurvafix, tohle uspělo! Ouha!'
    fi
    if (set -e -o pipefail; (exit 7;) | (exit 0;);); then
      echo 'Tohle se neobjeví, díky pipefail!'
    else
      echo 'Teď jsme démona chytili! Jmenuje se '"${?}."
    fi
    

    … nebo, hrůza pomyslet, pole PIPESTATUS:

    (
    set -e
    (exit 7;) | (exit 0;)
    for status in "${PIPESTATUS[@]}"; do (exit "${status}";); done
    )
    echo "Status je ${?}"': Chytili jsme ho (pracně) bez pipefail!'
    

    Tak nevím, jak kdo, ale já sázím na set -o pipefail. (Nebo když jsme na začátku souboru, tak set -e -o pipefail, protože nám to nemá co selhávat, pokud to selhání netestujeme nebo nenegujeme.)

  • U těch „složených příkazů“ mi trochu chybí break a continue. Jasně, obojí je zjevné, ale možná se to hodí jako malý referenční úvod pro někoho, kdo nikdy (nijak jinak) neprogramoval.

    for ((i = 0; i < 10; ++i)); do
      if ((i % 3)); then continue; fi
      echo "$i"
    done
    
  • Trochu (ale opravdu jenom trochu) tam chybí něco o file descriptorech a jejich dědění. Což vypadá neužitečně, ale jen dokud si člověk nepoloží otázku: Jak větvit dýmku?! No, není to úplně přímočaré, ale základem takových triků jsou podivně očíslované file descriptory…

    echo blah | (cat 1>&7; echo zee >&5;) 7>&1 5>&2
    

    … a další vychytávky se spoustou fantazie. Tohle samozřejmě zdaleka není celé; bude tam hrát roli řada (více či méně ad-hoc) externích souborů a dýmek.

    echo blah | cat <(cat <(cat <(cat)))
    echo blah | cat < <(cat < <(cat < <(cat)))
    

    (Bez mktemp a mkfifo to nepůjde. (Pravda, nizozemský hacker Johan van der Praase dokázal větvit dýmky jenom s mkfifo.))

  • U funkcí celkem citelně chybí nějaké podrobnosti, třeba return versus exit, ale hlavně (především!) klíčové slovo local, obdoba declare, a jeho kombinace s argumenty pro declare:

    keys() {
      local -n source="$1"
      local -n target="$2"
      target=("${!source[@]}")
    }
    
    values() {
      local -n source="$1"
      local -n target="$2"
      target=("${source[@]}")
    }
    
    declare -Ar blah=([hovno]=bullshit [vole]=dude)
    declare -a blah_keys blah_values
    
    keys blah blah_keys
    values blah blah_values
    
    echo 'Keys:' "${blah_keys[@]}"
    echo 'Values:' "${blah_values[@]}"
    

    (Zdá se, že reference na proměnné lze mít jenom do hloubky rekurze 8. Při větší hloubce nastane šílené peklo, na které jsem si teď už zase vzpomněl a konečně jsem ho nahlásil.)

  • Povídání o blocích (subshell, seskupení příkazů, různé cykly) by se možná hodilo doplnit o detaily kolem vstupu a výstupu z/do těchto bloků, což je hezký trik, na který se ve skriptech hodně zapomíná. Další důležitá věc je taky vstup a výstup z/do polí, tedy například readarray a read -a. Krátká ukázka všeho zmíněného:

    readarray -t entire_lines < /etc/passwd
    declare -i ctr=0
    for entire_line in "${entire_lines[@]}"; do
      echo "$entire_line"
    done |\
    while IFS=: read -a line_fields; do
      echo "Line ${ctr} in its entirety:"
      echo "  ${entire_lines[ctr]}"
      echo "Fields on line ${ctr}:"
      for line_field in "${line_fields[@]}"; do
        echo "  * $line_field"
      done
      echo "Line ${ctr} reassembled:"
      (IFS=:; echo "  ${line_fields[*]}")
      echo
      ((++ctr))
    done
    
  • Zajímavý je taky vztah funkcí k proměnným (zejména lokálním):

    recursion() {
      local -ri order="$1"
      if [[ -z "${cache[order]+set}" ]]; then
        recursion $((order - 2))
        recursion $((order - 1))
        cache[order]='cache[order - 2] + cache[order - 1]'
      fi
    }
    
    fibonacci() {
      local -ri order="$1"
      local -ai cache=(0 1)
      recursion "$order"
      echo ${cache[order]}
    }
    
    for n in {92..0}; do
      printf '%#2d. ' "$n"
      fibonacci "$n"
    done
    

    (Naopak vztah funkcí ke globálním proměnným a k jmennému prostoru funkcí není zajímavý, nýbrž děsivý.) Samozřejmě jde bez rekurze všechno lépe a rychleji, jako skoro vždy:

    fibonacci() {
      local -ri order="$1"
      local -i a=0 b=1
      local -i ctr=0
      for ((;;)); do
        if ((++ctr > order)); then echo "$a"; break; fi
        b='a + b'
        if ((++ctr > order)); then echo "$b"; break; fi
        a='a + b'
      done
    }
    
    for n in {92..0}; do
      printf '%#2d. ' "$n"
      fibonacci "$n"
    done
    

    Momentálně se nedá jít přes 92, protože to přeteče.

ǑǦŹǓǕǙǞǺǨȞȬḔḦḰḾṊṎṸẄẌỖ
25.4. 13:10 Andrej | skóre: 47 | blog: Republic of Mordor | Zürich
Rozbalit Rozbalit vše Re: prechadzanie logov
  • Dvourozměrné pole:

    A=('abcd' 'dcba')
    Z=('zxyw' 'wxyu' 'tuxz')
    ARR=('A' 'Z')
    
    for row in "${ARR[@]}"; do
      echo "processing row: $row"
      declare -n arr="$row"  # <<< Tohle!
      for element in "${arr[@]}"; do
        echo "  processing element: $element"
      done
    done
    

Tady^^^ jsem ještě zapomněl, že referenci stačí nadeklarovat jenom jednou a že se dá u ní (také) použít vykřičník, který má opačný „účinek“ než u běžné proměnné. Ale to už je asi detail. Takhle by to vypadalo:

A=('abcd' 'dcba')
Z=('zxyw' 'wxyu' 'tuxz')
ARR=('A' 'Z')

declare -n arr  # <<< Tohle!
for arr in "${ARR[@]}"; do
  echo "processing row: ${!arr}"
  for element in "${arr[@]}"; do
    echo "  processing element: $element"
  done
done
ǑǦŹǓǕǙǞǺǨȞȬḔḦḰḾṊṎṸẄẌỖ
25.4. 14:43 Aleš Kapica | skóre: 50 | blog: kenyho_stesky | Ostrava
Rozbalit Rozbalit vše Re: prechadzanie logov
Díky. Nebudu zastírat, že zrovna od tebe mě to uznání těší.
25.4. 14:48 Aleš Kapica | skóre: 50 | blog: kenyho_stesky | Ostrava
Rozbalit Rozbalit vše Re: prechadzanie logov
Jenom je tam pár věcí, které vypadají spíš jako z doby Bashe 3.x než z doby Bashe 5.x.
Já to psal v době kdy byl jenom Bash 3.x

Od té doby sotva stíhám doplňovat a opravovat stránky na vlastní wiki, jak ostatně zjistili ti, co koukali na můj manuál ohledně Qemu. Výhodou wikibooks je, že tam sem tam přispěje i někdo jiný.

Založit nové vláknoNahoru

Tiskni Sdílej: Linkuj Jaggni to Vybrali.sme.sk Google Del.icio.us Facebook

ISSN 1214-1267   www.czech-server.cz
© 1999-2015 Nitemedia s. r. o. Všechna práva vyhrazena.